Package: rawDiag
Type: Package
Title: Brings Orbitrap Mass Spectrometry Data to Life; Fast and
        Colorful
Version: 1.9.0
Authors@R: c(person(given = "Christian", family = "Panse",
      email = "cp@fgcz.ethz.ch", role = c("aut", "cre"),
    comment = c(ORCID = "0000-0003-1975-3064")),
	person(given = "Christian", family = "Trachsel",
	  email = "Christian.Trachsel@fgcz.ethz.ch", role = "aut"),
	person(given = "Tobias", family = "Kockmann",
	  email = "Tobias.Kockmann@fgcz.ethz.ch", role = "aut"))
Depends: R (>= 4.4)
Imports: dplyr, ggplot2 (>= 3.4), grDevices, hexbin, htmltools,
        BiocManager, BiocParallel, rawrr (>= 1.15.5), rlang, reshape2,
        scales, shiny (>= 1.5), stats, utils
Suggests: BiocStyle (>= 2.28), ExperimentHub, tartare, knitr, testthat
Description: Optimizing methods for liquid chromatography coupled to mass
  spectrometry (LC-MS) poses a nontrivial challenge. The rawDiag package
  facilitates rational method optimization by generating MS operator-tailored
  diagnostic plots of scan-level metadata. The package is designed for use on
  the R shell or as a Shiny application on the Orbitrap instrument PC.
License: GPL-3
URL: https://github.com/fgcz/rawDiag/
BugReports: https://github.com/fgcz/rawDiag/issues
Encoding: UTF-8
NeedsCompilation: no
RoxygenNote: 7.3.2
VignetteBuilder: knitr
biocViews: MassSpectrometry, Proteomics, Metabolomics, Infrastructure,
        Software, ShinyApps
git_url: https://git.bioconductor.org/packages/rawDiag
git_branch: devel
git_last_commit: d2d26ca
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-29 00:33:29 UTC; biocbuild
Author: Christian Panse [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-1975-3064>),
  Christian Trachsel [aut],
  Tobias Kockmann [aut]
Maintainer: Christian Panse <cp@fgcz.ethz.ch>

[![JPR](https://img.shields.io/badge/JPR-10.1021%2Facs.jproteome.8b00173-brightgreen)](http://dx.doi.org/10.1021/acs.jproteome.8b00173)

# rawDiag 

![octopussy](vignettes/octopussy.png)

an R package supporting rational LC-MS method optimization for bottom-up proteomics on multiple OS platforms

main features:
 
1. **multiplatform** and **fast** reading through using [The New RawFileReader from Thermo Fisher Scientific](http://planetorbitrap.com/rawfilereader).
2. uses latest visualization generation through using Rs [ggplot2](https://cran.r-project.org/package=ggplot2) package.
3. provides an R interface to your instrument raw data.
4. ships with an example [shiny application](http://fgcz-ms-shiny.uzh.ch:8080/bfabric_rawDiag/).

## ----style, results = 'asis'--------------------------------------------------
BiocStyle::markdown()
knitr::opts_chunk$set(fig.wide = TRUE, fig.retina = 3, error=FALSE, eval=TRUE)

## ----rawDiagLogo, out.width="50%", fig.cap="The octopussy `rawDiag` package logo by Lilly van de Venn."----
knitr::include_graphics("octopussy.png")

## ----installRawrr, eval=FALSE-------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("rawrr")

## ----checkInstallRequirements-------------------------------------------------
rawDiag::checkRawrr
rawDiag::checkRawrr()

rawrr::installRawrrExe()

## ----listrawrrAssemblyPath----------------------------------------------------
rawrr::rawrrAssemblyPath()
rawrr::rawrrAssemblyPath() |> list.files()

## ----fetchFromExperimentHub---------------------------------------------------
library(ExperimentHub)
ExperimentHub::ExperimentHub() -> eh
normalizePath(eh[["EH3222"]]) -> EH3222
normalizePath(eh[["EH4547"]]) -> EH4547

(rawfileEH3222 <- paste0(EH3222, ".raw"))
if (!file.exists(rawfileEH3222)){
  file.copy(EH3222, rawfileEH3222)
}

(rawfileEH4547 <- paste0(EH4547, ".raw"))
if (!file.exists(rawfileEH4547)){
  file.copy(EH4547, rawfileEH4547)
}

c(rawfileEH3222, rawfileEH4547) -> rawfile

## ----header-------------------------------------------------------------------
(rawfile |>
  lapply(FUN = rawrr::readFileHeader) -> rawFileHeader)

## ----readEH4547OrbitrapTrailerTable-------------------------------------------
rawfile |>
  lapply(FUN = rawDiag::readRaw) |>
  Reduce(f = rbind) -> x
  #BiocParallel::bplapply(FUN = rawDiag::readRaw) |>

## ----listFUN------------------------------------------------------------------
library(rawDiag)
ls("package:rawDiag") |>
  grep(pattern = '^plot', value = TRUE) -> pm

pm |>
  knitr::kable(col.names = "package:rawDiag plot functions")

## ----plotALL, fig.width = 10, fig.height = 5----------------------------------
pm |> 
  lapply(FUN = function(plotFUN) {
    lapply(c('trellis'), function(method) {
      message("plotting", plotFUN, "using method", method, "...")
      do.call(plotFUN, list(x, method)) 
    })
  }) 

## ----shinyApp-----------------------------------------------------------------
rawfile |>
  dirname() |>
  rawDiag::buildRawDiagShinyApp() -> app

## ----runApp, eval=FALSE-------------------------------------------------------
# shiny::runApp(app)

## ----FAQ1, eval=FALSE---------------------------------------------------------
# file.path(Sys.getenv("HOME"), "Downloads") |>
#   setwd()
# 
# list.files() |>
#   grep(pattern = '*.raw$', value = TRUE) |>
#   lapply(FUN = rawDiag::readRaw) |>
#   Reduce(f = rbind) -> x

## ----sessioninfo, eval=TRUE---------------------------------------------------
sessionInfo()

#R                                                                                                                                                            
                                                                                                                                                              
library(testthat)                                                                                                                                             
                                                                                                                                                              
suppressPackageStartupMessages(library(rawDiag))                                                                                                                

rawDiag::checkRawrr()

rawrr::installRawrrExe()
                                                                                                                                                              
test_check("rawDiag")   

#R

#' @noRd
#' @importFrom shiny fluidPage titlePanel sidebarLayout sidebarPanel mainPanel downloadButton downloadHandler
.buildRawDiagServer <- function(input, output, session) {

    vals <- reactiveValues(rawfile  = NA, gp = NULL, pdfFileName = NULL,
                           plot = NULL, generatePDF = 0)

    observeEvent(input$rawfile, {
        vals$rawfile = input$rawfile;
        message(vals$rawfile )
    })

    observeEvent(input$generatePDF, {
        vals$generatePDF <- vals$generatePDF + 1
    })
    rawDiag::rawDiagServer("OrbitrapFun02", vals)

    output$downloadPdf <- downloadHandler(
        filename = function() {
            basename(vals$pdfFileName)
        },
        content = function(file) {
            file.copy(
                from = vals$pdfFileName,
                to = file
            )
        }
    )
}

#' @noRd
#' @importFrom shiny fluidPage titlePanel sidebarLayout sidebarPanel mainPanel downloadButton downloadHandler actionButton
.buildRawDiagUI <- function(files){
  ## Define UI for application that draws a histogram
  fluidPage(
    ## Application title
    titlePanel("rawDiag - Brings Orbitrap Mass Spectrometry Data to Life; Fast and Colorful"),

    ## Sidebar with a slider input for number of bins
    sidebarLayout(
      sidebarPanel(
        tagList(
          # html::img(src='https://github.com/cpanse/rawDiag/blob/main/vignettes/octopussy.png', height = 100),
          selectInput("rawfile", "rawfile",
                      choices = files,
                      selected = files[1], width = "100%", multiple = TRUE),
          actionButton('generatePDF', 'generatePDF'),
          downloadButton("downloadPdf", "Download")
        )
      ),
      mainPanel(
        rawDiag::rawDiagUI("OrbitrapFun02")
      )
    )
  )
}

#' Build the rawDiag shiny application
#'
#' @param rawDir A directory containing the input raw files,
#' default is set to the \code{$HOME/Downloads} directory.
#' @importFrom shiny runApp
#' @import shiny
#' @return returns the rawDiag shiny apps
#' @inherit plotLockMassCorrection author references
#' @export
#'
#' @examplesIf interactive()
#' rawrr::sampleFilePath() |>
#'   dirname() |>
#'   rawDiag::buildRawDiagShinyApp() |>
#'   shiny::runApp()
#'   
#'  # or use your 'Download' folder
#'  (Sys.getenv('HOME') |>
#'    file.path("Downloads")) |>
#'    rawDiag::buildRawDiagShinyApp() |>
#'    shiny::runApp()
#'
#' @note launch the shiny application by embracing your command line while
#' expecting the raw file in \code{$HOME/Downloads}
#' * MacOSX and Linux: `R -q -e "library(rawDiag); buildRawDiagShinyApp() |> shiny::runApp(launch.browser = TRUE)"`
#' * Microsoft Windows: `R.exe -e "library(rawDiag); buildRawDiagShinyApp() |> shiny::runApp(launch.browser = TRUE)"`
#' @md
buildRawDiagShinyApp <- function(rawDir = (rawrr::sampleFilePath() |> dirname())){

  rawDir |>
    file.path(rawDir |>
                list.files(recursive = TRUE,
                           pattern = "*.raw$")) -> files
  
  if (length(files) == 0){
    warning("No raw files found in ", rawDir, " using raw file",
            rawrr::sampleFilePath())
    rawrr::sampleFilePath() -> files
  }

  vapply(files, FUN = file.mtime, FUN.VALUE = 1702718537) |>
    order() -> idx
  files[rev(idx)] -> files

  shiny::shinyApp(ui = .buildRawDiagUI(files), server = .buildRawDiagServer)
}

#' rawDiag shiny module UI
#' @return a shiny UI module
#' @inheritParams shiny::moduleServer
#' @returns rawDiag shiny module UI
#' @importFrom shiny fluidRow column
#' @importFrom htmltools a img
#' @examplesIf interactive()
#' rawDiag::shiny(rawDir = (rawrr::sampleFilePath() |> dirname()))
#' @export
rawDiagUI <- function(id){
  ns <- NS(id)
  
  ls("package:rawDiag")[ls("package:rawDiag") |> grepl(pattern = "^plot")] -> plotFunctions 
  
  tagList(
    column(12, offset = 0,
           #fluidRow(a(img(src="https://img.shields.io/badge/JPR-10.1021%2Facs.jproteome.8b00173-brightgreen"),
           #           href='http://dx.doi.org/10.1021/acs.jproteome.8b00173')),
           fluidRow(
             # FGCZ wants to have TIC and BPC 1st
             column(width = 4,
                    selectInput(ns("plotFUN"), "function", choices = plotFunctions,
                                selected = plotFunctions[which(plotFunctions == "plotTicBasepeak")], multiple = FALSE)),
             column(width = 4,
                    selectInput(ns("plotArg"), "argument", choices = c("trellis", "violin", "overlay"),
                                selected = "trellis", multiple = FALSE),
             ),
             column(width = 3,
                    # checkboxInput(ns('useParallel'), 'Use parallel processing (mclapply)', value = TRUE)
                    ## TODO(cpanse)
                    # checkboxInput(ns('readFileHeader'), 'readFileHeader (rawrr)', value = FALSE)
             )),
           fluidRow(
             column(width = 4,
                    selectInput(ns("plotHeight"), "height x n", choices = seq_len(10),
                                selected = 1, multiple = FALSE)),
             column(width = 4,
                    selectInput(ns("plotWidth"), "width x n", choices = seq_len(4),
                                selected = 1, multiple = FALSE),
             )),
           fluidRow(
             plotOutput(ns("plot"), width = "100%")
           ),
    ))
}

#' rawDiag shiny module
#'
#' @inheritParams shiny::moduleServer
#' @param vals containing rawfile
#' @return rawDiag shiny module server
#' @importFrom shiny moduleServer reactive reactiveValues observeEvent renderPlot req NS tagList selectInput checkboxInput plotOutput debounce
#' @importFrom utils packageVersion
#' @importFrom BiocParallel bplapply
#' @importFrom htmltools a img div
#' @examplesIf interactive()
#' shiny::shiny(rawDir = (rawrr::sampleFilePath() |> dirname()))
#' @export
rawDiagServer <- function(id, vals){
  moduleServer(id,
               function(input, output, session) {
                 rawfile <- reactive({ vals$rawfile }) |>
                   debounce(500)
                 
                 data <- reactive({
                   shiny::req(rawfile())
                   progress <- shiny::Progress$new(session = session)
                   progress$set(message = "Reading Index ...")
                   on.exit(progress$close())
                   vals$pdfFileName <- NULL
                   ## TODO(cp): think about as.rawDiag to ensure all columns are there.
                   
                   BiocParallel::bplapply(rawfile(), function(f){
                     rawDiag::readRaw(f,
                                      msgFUN = function(msg){
                                        progress$set(detail = paste0("from file ", basename(f)),
                                                     message = msg)
                                      })
                   }) |>
                     Reduce(f = rbind)
                   
                 })
                 
                 
                 observeEvent(input$plotFUN, {
                   vals$plot <- input$plotFUN;
                   message(input$plotFUN)
                 })
                 
                 
                 dynamicHeight <- reactive({
                   n <- 400
                   if (input$plotArg == "trellis"){
                     n <- n * length(rawfile()) 
                   }
                   
                   # n * as.integer(input$plotHeight)
                 })
                 
                 dynamicWidth <- reactive({
                   n <- 400
                   if (input$plotArg == "trellis"){
                     400 
                   }
                   n * as.integer(input$plotWidth)
                 })
                 
                 output$plot <- renderPlot({
                   shiny::req(data())

                   progress <- shiny::Progress$new(session = session)
                   progress$set(message = "plotting ...")
                   on.exit(progress$close())
                   
                   ## call the plot method
                   do.call(what = input$plotFUN,
                           args = list(x = data(),
                                       method = input$plotArg)) -> gp
                   vals$gp <- gp
                   gp
                 },
                 height = function()dynamicHeight())
                 
                 observeEvent(vals$generatePDF, {
                   shiny::req(data())
                   pdfFileName <- tempdir() |>
                     file.path(paste0("rawDiag",
                                      format(Sys.time(), "_%Y%m%d-%H%M%S_"),
                                      vals$plot, '.pdf'))
                   
                   msg <- paste0("ggplot2::ggsave to file ", pdfFileName)
                   progress <- shiny::Progress$new(session = session, min = 0, max = 1)
                   progress$set(message = msg)
                   on.exit(progress$close())
                   
                   gglabs <- ggplot2::labs(
                     caption = paste0("Generated on ", 
                                      format(Sys.time(), "%Y-%m-%d %H:%M:%S"),
                                      ", @", Sys.info()["nodename"],
                                      " using the rawrr/rawDiag R package versions ", 
                                      packageVersion('rawrr'), "/",
                                      packageVersion('rawDiag'), " ",
                                      R.Version()['version.string'],
                                      ". If you want to cite rawrr and rawDiag in your work, use:\n",
                                      "T. Kockmann and C. Panse (2021), Journal of Proteome Research doi: 10.1021/acs.jproteome.0c00866; ",
                                      "C. Trachsel et al. (2018), Journal of Proteome Research doi: 10.1021/acs.jproteome.8b00173"))
                   
                   rvgg <- ggplot2::ggsave(
                     vals$gp + gglabs,
                     filename = pdfFileName,
                     dpi = 600,
                     device = "pdf",
                     width = 297 * as.integer(input$plotWidth),
                     height = 210 * as.integer(input$plotHeight),
                     units = 'mm',
                     limitsize = FALSE)
                   
                   if (file.exists(pdfFileName)){
                     vals$pdfFileName <- pdfFileName
                   } else{
                     vals$pdfFileName <- NULL
                   }
                 })
                 
               }
  )
}

#R
#' Reads selected raw file trailer information for rawDiag plot functions
#'
#' implements a wrapper function using the rawrr methods
#' \code{\link[rawrr]{readIndex}}, \code{\link[rawrr]{readTrailer}},
#' and \code{\link[rawrr]{readChromatogram}} to read
#' proprietary mass spectrometer generated data using third-party libraries.
#'
#' @note
#' The set up procedure for the rawrr package needs to be run in order to use
#' this package.
#'
#' @inheritParams rawrr::readIndex
#' @param msgFUN this function is used for logging information while composing
#' the resulting data.frame. It can also be used for shiny progress bar. The
#' default is using the \code{message}.
#' @return a \code{data.frame} containing the selected trailer information.
#' @author Christian Panse (2016-2023)
#' @aliases rawDiag readRaw
#' @examples
#' rawDiag::checkRawrr()
#' rawrr::sampleFilePath() |>
#'   rawDiag::readRaw()
#' @importFrom rawrr readIndex readTrailer readChromatogram
#' @export
#' @references \doi{10.1021/acs.jproteome.8b00173}
readRaw <- function(rawfile, msgFUN = function(x){message(x)}){
  message("reading index for ", basename(rawfile), "...")

  t0 <- Sys.time()
  rawfile |>
    rawrr::readIndex() -> rawrrIndex
  rawrrIndex$rawfile <- basename(rawfile)

  rawfile |>
    rawrr::readTrailer() -> trailerNames

  msgFUN("determining ElapsedScanTimesec ...")
  rawrrIndex$ElapsedScanTimesec <- c(diff(rawrrIndex$StartTime), NA)

  if ("LM m/z-Correction (ppm):" %in% trailerNames){
    msgFUN("reading trailer LM m/z-Correction (ppm) ...")
    rawfile |>
      rawrr::readTrailer("LM m/z-Correction (ppm):") |>
      as.numeric() -> LMCorrection
    rawrrIndex$LMCorrection <- LMCorrection
  }else{
    rawrrIndex$LMCorrection <- NA
  }

  if ("AGC:" %in% trailerNames){
    msgFUN("reading trailer AGC ...")
    rawfile |>
      rawrr::readTrailer("AGC:") -> AGC
    rawrrIndex$AGC <- AGC
  }else{
    rawrrIndex$AGC <- NA
  }

  if ("AGC PS Mode:" %in% trailerNames){
    msgFUN("reading trailer AGC PS Mode ...")
    rawfile |>
      rawrr::readTrailer("AGC PS Mode:") -> PrescanMode
    rawrrIndex$PrescanMode <- PrescanMode
  }else{
    rawrrIndex$PrescanMode <- NA
  }

  if ("FT Resolution:" %in% trailerNames){
    msgFUN("reading trailer FT Resolution ...")
    rawfile |>
      rawrr::readTrailer("FT Resolution:") |>
      as.numeric() -> FTResolution
    rawrrIndex$FTResolution <- FTResolution
  }else if ("Orbitrap Resolution:" %in% trailerNames){
    msgFUN("reading trailer Orbitrap Resolution ...")
    rawfile |>
      rawrr::readTrailer("Orbitrap Resolution:") |>
      as.numeric() -> FTResolution
    rawrrIndex$FTResolution <- FTResolution
  }else{
    rawrrIndex$FTResolution <- NA
  }

  if ("Ion Injection Time (ms):" %in% trailerNames){
    msgFUN("reading trailer Ion Injection Time (ms) ...")
    rawfile |>
      rawrr::readTrailer("Ion Injection Time (ms):") |>
      as.numeric() -> IonInjectionTime
    rawrrIndex$IonInjectionTime <- IonInjectionTime
  }else{
    rawrrIndex$IonInjectionTime <- NA
  }

  if (sum(rawrrIndex$MSOrder == "Ms") > 0){
    msgFUN("reading TIC ...")
    rawrrIndex$TIC <- NA
    rawfile |> rawrr::readChromatogram(type = 'tic') -> tic
    rawrrIndex$TIC[rawrrIndex$MSOrder == "Ms"] <- tic$intensities
    
    msgFUN("reading BasePeakIntensity ...")
    rawrrIndex$BasePeakIntensity <- NA
    rawfile |> rawrr::readChromatogram(type = 'bpc') -> bpc
    rawrrIndex$BasePeakIntensity[rawrrIndex$MSOrder == "Ms"] <- bpc$intensities
  }else{
    msgFUN("no scans with MSOrder 'Ms', skipping TIC and BasePeakIntensity ...")
    rawrrIndex$BasePeakIntensity <- NA
    rawrrIndex$TIC <- NA
  }
  t1 <- Sys.time()
  
  td <- difftime(t1, t0, units = "secs") |>
    round(3) 
  
  msgFUN(paste0("reading took ", td, " seconds."))
  
  rawrrIndex |>
    validate_readRaw()
}


.rawDiagColumns <- function(){
    c("scan", "scanType", "StartTime", "precursorMass",
      "MSOrder", "charge", "masterScan", "dependencyType",
      "TIC", "BasePeakIntensity", "ElapsedScanTimesec", "rawfile", "AGC",
      "LMCorrection", "PrescanMode", "FTResolution") |>
        sort()
}

#' Is an Object an rawDiag Object?
#'
#' @inheritParams methods::is
#' @return a boolean
#' @author Christian Panse 2018
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::is.rawDiag()
#'
#' @export
is.rawDiag <- function(object){
    cn <- .rawDiagColumns()

    msg <- cn[! cn %in% colnames(object)]
    if (length(msg) > 0){
        message("missing column name(s):", paste(msg, collapse = ", "))
        return(FALSE)
    }

    return(TRUE)
}

validate_readRaw <- function(x){
  validateIndex <- TRUE

  if (!is.data.frame(x)){
    message("Object is not a 'data.frame'.")
    valideIndex <- FALSE
  }

  IndexColNames <- .rawDiagColumns()

  for (i in IndexColNames){
    if (!(i %in% colnames(x))){
      msg <- sprintf("Missing column %s.", i)
      warning(msg)
      valideIndex <- FALSE
    }
  }

  # stopifnot(valideIndex)
  return(x)
}


#' @importFrom ggplot2 geom_blank theme_void
.plotMissingData <- function(){
  ggplot2::ggplot() +
    ggplot2::geom_blank() +
    ggplot2::theme_void() +
    ggplot2::labs(
      title = "Oops! Missing Data Detected",
      subtitle = "It seems there are missing values in your data.",
      caption = "Please handle missing data before creating the plot."
    )
}

#' Lock Mass Correction Plot
#'
#' @param x a \code{data.frame} object adhering to the specified criteria for
#' the \code{is.rawDiag} function.
#' @param method specifying the plot method 'trellis' | 'violin' | 'overlay'.
#' The default is 'trellis'.
#'
#' @return a \code{\link[ggplot2]{ggplot}} object.
#'
#' @author Christian Trachsel (2017), Christian Panse (2023)
#'
#' @references
#' * rawDiag: \doi{10.1021/acs.jproteome.8b00173},
#' * rawrr: \doi{10.1021/acs.jproteome.0c00866}
#' @md
#' @examples
#' rawrr::sampleFilePath() |>
#'   rawDiag::readRaw() |>
#'   rawDiag::plotLockMassCorrection()
#'
#' @importFrom ggplot2 ggplot aes_string geom_hline geom_line labs scale_x_continuous facet_wrap theme_light
#' @export
#' @aliases PlotLockMassCorrection
plotLockMassCorrection <- function(x, method = 'trellis'){
  if(isFALSE("LMCorrection" %in% colnames(x))) {return(.plotMissingData())}

  x |>
    base::subset(x['MSOrder'] == "Ms") -> x

  if (method %in% c('trellis')){
    x |>
      ggplot2::ggplot(ggplot2::aes(x = .data$StartTime , y = .data$LMCorrection)) +
      ggplot2::geom_hline(yintercept = c(-5, 5), colour = "red3", linetype = "longdash") +
      ggplot2::geom_line(linewidth = 0.3) +
      ggplot2::geom_line(stat = "smooth",
                         method= "gam",
                         formula = y ~ s(x, bs ="cs"),
                         colour = "deepskyblue3", se = FALSE) -> gp
  }else if(method %in% c('overlay')){
    x |>
      ggplot2::ggplot(ggplot2::aes(x = .data$StartTime , y = .data$LMCorrection, colour = .data$rawfile)) +
      ggplot2::geom_hline(yintercept = c(-5, 5), colour = "red3", linetype = "longdash") +
      ggplot2::geom_line(linewidth = 0.3) +
      ggplot2::geom_line(stat = "smooth",
                         method= "gam",
                         formula = y ~ s(x, bs ="cs"),
                         colour = "deepskyblue3", se = FALSE) -> gp
  }else{
    x |>
      ggplot2::ggplot(ggplot2::aes(x = .data$StartTime , y = .data$LMCorrection)) +
      ggplot2::geom_hline(yintercept = c(-5, 5), colour = "red3", linetype = "longdash") +
      ggplot2::geom_violin() -> gp
  }
  gp +
    ggplot2::labs(title = "Lock mass correction plot") +
    ggplot2::labs(subtitle = "Plotting lock mass correction value versus retention time") +
    ggplot2::labs(x = "Retention Time [min]", y = "Lock Mass Correction [ppm]") +
    ggplot2::scale_x_continuous(breaks = base::pretty(8)) +
    # scale_y_continuous(breaks = scales::pretty_breaks(8), limits = c(-10, 10)) +
    ggplot2::facet_wrap(~ rawfile) +
    ggplot2::theme_light() -> gp

  gp
}

#' Precursor Mass versus StartTime MS2 based hexagons
#'
#' @inherit plotLockMassCorrection params return references author
#' @param bins number of bins in both vertical and horizontal directions. default is 80.
#' @author Christian Trachsel (2017)
#' @note TODO: define bin with dynamically as h= 2x IQR x n e-1/3 or number of bins (max-min)/h
#' @import hexbin
#' @importFrom ggplot2 ggplot aes_string geom_hex labs scale_fill_gradientn theme_light
#' @importFrom grDevices colorRampPalette
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotPrecursorHeatmap()
#' @export
#' @aliases PlotPrecursorHeatmap
plotPrecursorHeatmap <- function(x, method = 'overlay', bins = 80){
  spectral <- c("#5E4FA2",
                "#3288BD",
                "#66C2A5",
                "#ABDDA4",
                "#E6F598",
                "#FFFFBF",
                "#FEE08B",
                "#FDAE61",
                "#F46D43",
                "#D53E4F",
                "#9E0142")

  spectralramp <- colorRampPalette(spectral)

  x |>
    base::subset(x['MSOrder'] == "Ms2") |>
    ggplot2::ggplot(ggplot2::aes_string(x = 'StartTime', y = 'precursorMass')) +
    ggplot2::labs(x = "Retention Time [min]", y = "Precursor Mass [Da]") +
    ggplot2::geom_hex(bins = bins) +
    ggplot2::scale_fill_gradientn(colours = spectralramp(32)) +
    ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
    ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(15)) +
    ggplot2::theme_light() -> gp

  if (method == 'trellis'){
    gp +
      ggplot2::facet_wrap(~ rawfile) -> gp
  }

  gp +
    ggplot2::labs(title = "precursorMass versus StartTime hexagons MS2")
}

#' Total Ion Count and Base Peak Plot
#'
#' displays the Total Ion Count (TIC) and the Base Peak Chromatogram
#' of a mass spectrometry measurement.
#' Multiple files are handled by faceting based on rawfile name.
#'
#' @inheritParams plotLockMassCorrection
#' @return a ggplot2 object for graphing the TIC and the Base Peak chromatogram.
#' @author Christian Trachsel (2017), Christian Panse (20231130) refactored
#' @importFrom ggplot2 ggplot aes_string geom_line labs scale_x_continuous facet_wrap theme_light
#' @importFrom reshape2 melt
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotTicBasepeak()
#' @export
#' @aliases PlotTicBasepeak
plotTicBasepeak <- function(x, method = 'trellis'){
  stopifnot(method %in% c('trellis', 'violin', 'overlay'))

  x[, c('StartTime', 'TIC', 'BasePeakIntensity', 'rawfile')] |>
    base::subset(x$MSOrder == "Ms") |>
    reshape2::melt(id.vars = c("StartTime", "rawfile")) -> xx

  if (method == 'trellis'){
    xx |>
      ggplot2::ggplot(ggplot2::aes_string(x = "StartTime", y = "value")) +
      ggplot2::geom_line(linewidth = 0.3) +
      ggplot2::facet_wrap(rawfile ~ variable, scales = "free", ncol = 2) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) -> gp
  }else if(method =='violin'){
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = "rawfile", y = "value")) +
      ggplot2::geom_violin() +
      ggplot2::facet_grid(variable ~ ., scales = "free") +
      #ggplot2::scale_y_continuous(trans = scales::log10_trans()) +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  }else if (method  == 'overlay'){
    xx |>
      ggplot2::ggplot(ggplot2::aes_string(x = "StartTime", y = "value", colour = "rawfile")) +
      ggplot2::geom_line(size = 0.3) +
      ggplot2::facet_grid(variable ~ ., scales = "free") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::theme(legend.position="top") -> gp
  }else{NULL}

  gp +
    ggplot2::labs(title = "Total Ion Count and Base-Peak plot") +
    ggplot2::labs(subtitle = "Plotting the TIC and base peak density for all mass spectrometry runs") +
    ggplot2::labs(x = "Retention Time [min]", y = "Intensity Counts [arb. unit]") +
    ggplot2::theme_light()
}


#' Calculate MS Cycle Time
#'
#' calculates the lock mass deviations along RT.
#'
#' @inheritParams plotLockMassCorrection
#'
#' @note TODO: quantile part needed? If no MS1 scan is present?
#' E.g., DIA take lowest window as cycle indicator?
#'
#' @importFrom stats na.omit
#' @author Christian Trachsel (2017), Christian Panse (20231201) refactored
#'
#' @return calculates the time of all ms cycles and the 95% quantile value there of.
#' the cycle time is defined as the time between two consecutive MS1 scans
.cycleTime <- function(x){
  x |>
    subset(x$MSOrder == "Ms") -> xx
  split(xx, xx$rawfile) |>
    lapply(function(o){
      o$CycleTime <- c(NA, (o$StartTime * 60) |> diff())
      o$quan <- quantile(o$CycleTime, probs = 0.95, na.rm = TRUE)
      o[, c('StartTime', 'CycleTime',  'quan', 'rawfile')]
    }) |>
    Reduce(f = rbind) |>
    na.omit()
}

#' Plot Cycle Time
#'
#' graphs the time difference between two consecutive MS1 scans
#' (cycle time) with respect to RT (scatter plots) or its density (violin).
#' A smooth curve graphs the trend. The 95th percentile is indicated by a red
#' dashed line.
#'
#' @inherit plotLockMassCorrection params return
#'
#' @importFrom ggplot2 ggplot aes geom_point geom_line scale_x_continuous scale_y_continuous geom_hline theme_light
#' @importFrom scales pretty_breaks
#' @importFrom dplyr left_join
#' @importFrom stats quantile na.omit
#' @importFrom rlang .data
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotCycleTime()
#' @export
#' @aliases PlotCycleTime
plotCycleTime <- function(x, method = 'trellis'){
  xx <- .cycleTime(x)

  if (method == 'trellis'){
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = .data$StartTime, y = .data$CycleTime)) +
      ggplot2::geom_point(shape = ".") +
      ggplot2::geom_line(stat = "smooth", method = "gam", formula = y ~ s(x, bs= "cs"),
                         colour = "deepskyblue3", se = FALSE) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::geom_hline(ggplot2::aes(yintercept = .data$quan, group = .data$rawfile),
                          colour = "red3", linetype = "longdash") +
      ggplot2::facet_grid(rawfile ~ ., scales = "free") +
      ggplot2::labs(subtitle = "Plotting the caclulated cycle time of each cycle vs retention time") +
      ggplot2::labs(x = "Retention Time [min]", y = "Cycle Time [sec]") -> gp
  }else if (method == 'violin'){
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = .data$rawfile, y = .data$CycleTime)) +
      ggplot2::geom_violin()  +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the cycle time density of all mass spectrometry runs") +
      ggplot2::labs(x = "rawfile", y = "Cycle Time [sec]") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  } else if(method == 'overlay'){
    xx|>
      ggplot2::ggplot(ggplot2::aes(x = .data$StartTime, y = .data$CycleTime, colour = .data$rawfile)) +
      ggplot2::geom_point(size = 0.5) +
      ggplot2::geom_line(ggplot2::aes(group = .data$rawfile,
                                             colour = .data$rawfile),
                         stat = "smooth", method = "gam",
                         formula = y ~ s(x, bs= "cs"), se = FALSE) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the caclulated cycle time of each cycle vs retention time") +
      ggplot2::labs(x = "Retention Time [min]", y = "Cycle Time [sec]") +
      ggplot2::theme(legend.position="top") -> gp

  }else{NULL}
  gp +
    ggplot2::labs(title = "Cycle time plot") +
    ggplot2::theme_light()
}



#' Plot Injection Time
#'
#' shows the injection time density of each mass spectrometry file as a violin
#' plot. The higher the maximum number of MS2 scans is in the method,
#' the more the density is shifted towards the maximum injection time value.
#'
#' @inherit plotLockMassCorrection params return  references author
#' @importFrom ggplot2 ggplot aes geom_point geom_line scale_x_continuous scale_y_continuous geom_hline theme_light
#' @importFrom rlang .data
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotInjectionTime()
#' @export
#' @aliases PlotInjectionTime
plotInjectionTime <- function(x, method = 'trellis'){
  if (method == 'trellis'){
    maxtimes <- x |>
      dplyr::group_by(.data$rawfile, .data$MSOrder) |>
      dplyr::summarise(maxima = max(.data$IonInjectionTime))

    ggplot2::ggplot(x, ggplot2::aes(x = .data$StartTime,
                                    y = .data$IonInjectionTime)) +
      ggplot2::geom_hline(data = maxtimes,
                          ggplot2::aes(yintercept = .data$maxima),
                          colour = "red3", linetype = "longdash") +
      ggplot2::geom_point(shape = ".") +
      ggplot2::geom_line(stat = "smooth", method = "gam",
                         formula = y ~ s(x, bs= "cs"),
                         colour = "deepskyblue3", se = FALSE) +
      ggplot2::facet_grid(rawfile ~ MSOrder, scales = "free") +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::labs(subtitle = "Plotting injection time against retention time for MS and MSn level") +
      ggplot2::labs(x = "Retentione Time [min]", y = "Injection Time [ms]") -> gp
  }else if (method == 'violin'){
    ggplot2::ggplot(x, ggplot2::aes(x = .data$rawfile,
                                    y = .data$IonInjectionTime)) +
      ggplot2::geom_violin() +
      ggplot2::facet_grid(MSOrder ~ .) +
      ggplot2::labs(subtitle = "Plotting retention time resolved injection time density for each mass spectrometry run") +
      ggplot2::labs(x = "rawfile", y = "Injection Time [ms]") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  }else if(method == 'overlay'){
    ggplot2::ggplot(x, ggplot2::aes(x = .data$StartTime,
                                    y = .data$IonInjectionTime, colour = .data$rawfile)) +
      ggplot2::geom_point(size = 0.5, alpha = 0.1) +
      ggplot2::geom_line(ggplot2::aes(group = .data$rawfile, colour = .data$rawfile),
                stat = "smooth",
                method = "gam",
                formula = y ~ s(x, bs= "cs"),
                se = FALSE) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::facet_grid(~ .data$MSOrder, scales = "free") +
      ggplot2::labs(subtitle = "Plotting injection time against retention time for MS and MSn level") +
      ggplot2::labs(x = "Retentione Time [min]", y = "Injection Time [ms]") +
      ggplot2::theme(legend.position = "top") -> gp
  }else{NULL}

  gp + ggplot2::labs(title = "Injection time plot") +
    ggplot2::theme_light()
}


#' mZ Distribution Plot of Ms2 Scans
#'
#' draws precursor mass vs retention time for each MS2 scan in the raw file.
#'
#' @inherit plotLockMassCorrection params return references author
#' @aliases PlotMzDistribution
#' @importFrom rlang .data
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() -> S
#' rawDiag::plotMzDistribution(S)
#' @export
#' @aliases PlotMzDistribution
plotMzDistribution <- function(x, method='trellis'){
    x |>
        dplyr::filter(.data$MSOrder == "Ms2") -> xx

    if (method == 'trellis'){
        ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime,
                                         y = .data$precursorMass)) +
            ggplot2::geom_point(shape = ".") +
            ggplot2::facet_grid(rawfile ~ ., scales = "free") +
            ggplot2::geom_line(stat = "smooth", method = "gam",
                               formula = y ~ s(x, bs= "cs"),
                               linewidth = 1.1, alpha = 0.6,
                               colour = "cornflowerblue", se = FALSE) +
            ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
            ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
            ggplot2::labs(subtitle = "Plotting retention time against m/z value of all selected precursors") +
            ggplot2::labs(x = "Retention Time", y = "Presursor m/z value") -> gp
    }else if (method == 'violin'){
        ggplot2::ggplot(xx, ggplot2::aes(x = .data$rawfile,
                                         y = .data$precursorMass)) +
            ggplot2::geom_violin() +
            ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
            ggplot2::labs(subtitle = "Plotting the precursor m/z value density of all mass spectrometry runs") +
            ggplot2::labs(x = "Filename", y = "Presursor m/z value [Da]") +
            ggplot2::theme_light() +
            ggplot2::theme(
                axis.text.x = ggplot2::element_text(angle = 90)) -> gp
    }else if (method == 'overlay'){
        ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime,
                                         y = .data$precursorMass,
                                         colour = .data$rawfile)) +
            ggplot2::geom_point(size = 0.5, alpha = 0.3) +
            ggplot2::geom_line(stat = "smooth",
                               method = "gam",
                               formula = y ~ s(x, bs= "cs"),
                               size = 1.1,
                               se = FALSE) +
            ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
            ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
            ggplot2::labs(subtitle = "Plotting retention time against m/z value of all selected precursors") +
            ggplot2::labs(x = "Retention Time [min]", y = "Presursor m/z value [Da]") +
            ggplot2::theme(legend.position="top") -> gp

    }else{NULL}
    gp +
      ggplot2::theme_light() +
      ggplot2::labs(title = "Retention Time to m/z correlation plot")
}


#' Mass Distribution Plot
#'
#' displays charge state resolved frequency of precursor masses.
#'
#' @description plots the mass frequency in dependency to the charge state
#' @inherit plotLockMassCorrection params return references author
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotMassDistribution('overlay')
#' @export
#' @aliases PlotMassDistribution
plotMassDistribution <- function(x, method = 'trellis'){
  x[x['MSOrder'] == 'Ms2', c('MSOrder', 'charge','rawfile', 'precursorMass')] -> xx

  xx$deconv <-  round((xx$precursorMass - 1.00782) * xx$charge, 0)
  xx$charge <- factor(xx$charge)
  if (method == 'trellis'){
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = .data$deconv, fill = .data$charge, colour = .data$charge)) +
      ggplot2::geom_histogram(binwidth = 50, alpha = 0.3, position = "identity") +
      ggplot2::labs(title = "Precursor mass to charge frequency plot ") +
      ggplot2::labs(subtitle = "Plotting charge state resolved frequency of precursor masses") +
      ggplot2::labs(x = "Precursor neutral mass [Da]", y = "Frequency [counts]") +
      ggplot2::labs(fill = "Charge State", colour = "Charge State") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::coord_cartesian(xlim = range(xx$deconv)) +
      ggplot2::facet_wrap(~ .data$rawfile) -> gp
  }else if (method == 'violin'){ #mz.frequency.violin
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = .data$charge, y = .data$deconv, fill = .data$rawfile)) +
      ggplot2::geom_violin() +
      ggplot2::labs(title = "Precursor mass to charge density plot ") +
      ggplot2::labs(subtitle = "Plotting the charge state resolved precursor masse density for each mass spectrometry run") +
      ggplot2::labs(x = "Charge State ", y = "Neutral Mass [Da]") +
      ggplot2::theme(legend.position = "top") -> gp
  }else if (method == 'overlay'){ #mz.frequency.overlay
    xx |>
      ggplot2::ggplot(ggplot2::aes(x = .data$deconv, colour = .data$rawfile)) +
      ggplot2::geom_line(stat = "density") +
      ggplot2::labs(title = "Precursor mass density plot ") +
      ggplot2::labs(subtitle = "Plotting the precursor masse density for each mass spectrometry run") +
      ggplot2::labs(x = "Precursor mass [neutral mass]", y = "Density") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(12)) +
      ggplot2::coord_cartesian(xlim = range(xx$deconv)) +
      ggplot2::theme(legend.position = "top") -> gp
  }else{NULL}
  gp +
      ggplot2::theme_light()
}

#' Charge State Overview Plot
#'
#' graphs the number of occurrences of all selected precursor charge states.
#'
#' @inherit plotLockMassCorrection params return references author
#' @importFrom rlang .data
#' @examples
#'  rawrr::sampleFilePath() |> rawDiag::readRaw() -> S
#'  S |> rawDiag::plotLockMassCorrection()
#' @export
#' @aliases PlotChargeState
plotChargeState <- function(x, method='trellis'){
  x |>
    dplyr::filter(.data$MSOrder == "Ms2") |>
    dplyr::group_by_at(dplyr::vars(.data$rawfile)) |>
    dplyr::count(.data$charge) |>
    dplyr::ungroup() |>
    dplyr::rename_at(dplyr::vars("n"), list(~ as.character("Counts"))) -> xx

  xx$percentage <- (100 / sum(xx$Counts)) * xx$Counts
  xbreaks <- unique(xx$charge)

  if (method == 'trellis'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$charge, y = .data$percentage)) +
      ggplot2::geom_bar(stat = "identity", fill = "cornflowerblue") +
      ggplot2::geom_text(ggplot2::aes(label = .data$Counts),
                         vjust=-0.3, size=3.5) +
      ggplot2::scale_x_continuous(breaks = xbreaks) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(15),
                                  expand = c(0, 0),
                                  limits = c(0, (max(xx$percentage)) + 3)) +
      ggplot2::labs(subtitle = "Plotting the number of occurrences of all selected precursor charge states") +
      ggplot2::labs(x = "Charge States", y = "Percent [%]") +
      ggplot2::facet_wrap(~ rawfile) -> gp
  }else if(method =='overlay'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$charge, y = .data$percentage,
                                     fill = .data$rawfile)) +
      ggplot2::geom_bar(stat = "identity", position = ggplot2::position_dodge(),
                        colour = "black") +
      ggplot2::scale_x_continuous(breaks = xbreaks) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(15),
                                  expand = c(0, 0),
                                  limits = c(0, (max(xx$percentage)) + 3)) +
      ggplot2::labs(subtitle = "Plotting the number of occurrences of all selected precursor charge states") +
      ggplot2::labs(x = "Charge States", y = "Percent [%]") +
      ggplot2::theme(legend.position = "top") -> gp
  }else if (method =='violin'){
   x |>
      dplyr::filter(.data$MSOrder == "Ms2")  -> xx
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$rawfile, y = .data$charge)) +
      ggplot2::geom_violin() +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the precursor charge state density for each mass spectrometry run") +
      ggplot2::labs(x = "Filename", y = "Charge State") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  }else{NULL}
  gp +
    ggplot2::theme_light() +
    ggplot2::labs(title = "Charge state plot")
}

.mapType <- function(x){
  x |>
    dplyr::mutate(Type = dplyr::case_when(grepl("FTMS [[:punct:]] c NSI Full ms", .data$scanType) == "TRUE" ~ "FT_Full_ms_c",
                                          grepl("FTMS [[:punct:]] p NSI Full ms", .data$scanType) == "TRUE" ~ "FT_Full_ms_p",
                                          grepl("FTMS [[:punct:]] c NSI Full lock ms", .data$scanType) == "TRUE" ~ "FT_Full_ms_c",
                                          grepl("FTMS [[:punct:]] p NSI Full lock ms", .data$scanType) == "TRUE" ~ "FT_Full_ms_p",
                                          grepl("FTMS [[:punct:]] c NSI d Full ms2", .data$scanType) == "TRUE" ~ "FT_d_Full_ms2_c",
                                          grepl("FTMS [[:punct:]] p NSI d Full ms2", .data$scanType) == "TRUE" ~ "FT_d_Full_ms2_p",
                                          grepl("FTMS [[:punct:]] c NSI SIM ms", .data$scanType) == "TRUE" ~ "FT_SIM_ms_c",
                                          grepl("FTMS [[:punct:]] p NSI SIM ms", .data$scanType) == "TRUE" ~ "FT_SIM_ms_p",
                                          grepl("FTMS [[:punct:]] p NSI SIM msx ms", .data$scanType) == "TRUE" ~ "FT_msxSIM_ms_p",
                                          grepl("FTMS [[:punct:]] c NSI SIM msx ms", .data$scanType) == "TRUE" ~ "FT_msxSIM_ms_c",
                                          grepl("FTMS [[:punct:]] c NSI Full ms2", .data$scanType) == "TRUE" ~ "FT_Full_ms2_c",
                                          grepl("FTMS [[:punct:]] p NSI Full ms2", .data$scanType) == "TRUE" ~ "FT_Full_ms2_p",
                                          grepl("ITMS [[:punct:]] c NSI r d Full ms2", .data$scanType) == "TRUE" ~ "IT_Full_ms2_c",
                                          grepl("ITMS [[:punct:]] p NSI r d Full ms2", .data$scanType) == "TRUE" ~ "IT_Full_ms2_p"
    )
    )

}


#TODO: supply cases as list
#patterns <- list(
#x %% 35 == 0 ~ "fizz buzz",
#x %% 5 == 0 ~ "fizz",
#x %% 7 == 0 ~ "buzz",
#TRUE ~ as.character(x)
#)
#case_when(!!! patterns)
.calcTransient <- function(x){
  x$MassAnalyzer <- NA
  x$MassAnalyzer[grepl(x$scanType, pattern="^ITMS")] <- "ITMS"
  x$MassAnalyzer[grepl(x$scanType, pattern="^FTMS")] <- "FTMS"

  x |>
    dplyr::mutate(transient = dplyr::case_when(FTResolution == 7500 ~ 16,
                                               FTResolution == 15000 ~ 32,
                                               FTResolution == 17500 ~ 64,
                                               FTResolution == 30000 ~ 64,
                                               FTResolution == 45000 ~ 96,
                                               FTResolution == 50000 ~ 96,
                                               FTResolution == 35000 ~ 128,
                                               FTResolution == 60000 ~ 128,
                                               FTResolution == 70000 ~ 256,
                                               FTResolution == 120000 ~ 256,
                                               FTResolution == 140000 ~ 512,
                                               FTResolution == 240000 ~ 512
    )
    )
}


#' Scan Event Plot
#'
#' Plotting the elapsed scan time for each individual scan event.
#'
#' @inherit plotLockMassCorrection params return references author
#' @importFrom rlang .data
#' @examples
#' ## for debugging bioconductor check
#'  if (Sys.info()['sysname'] %in% c("Darwin", "Linux")) {Sys.which('mono')}
#'  rawrr::sampleFilePath() |> rawDiag::readRaw() -> S
#'
#' rawDiag::checkRawrr()
#'
#' S |> rawDiag::plotScanTime()
#' @export
#' @aliases PlotScanTime
plotScanTime <- function(x, method='trellis'){
  x |>
    .calcTransient() |>
    dplyr::mutate(ElapsedScanTimesec = .data$ElapsedScanTimesec * 1000) |>
    dplyr::select_at(dplyr::vars("StartTime", "scanType", "ElapsedScanTimesec", "rawfile", "MassAnalyzer", "MSOrder", "transient")) |>
    na.omit() |>
    .mapType()-> xx
  if(method == 'trellis'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime, y = .data$ElapsedScanTimesec)) +
      ggplot2::geom_point(shape = ".") +
      ggplot2::facet_grid(rawfile ~ Type) +
      ggplot2::geom_line(stat = "smooth", method = "gam",
                         formula = y ~ s(x), colour = "deepskyblue3", se = FALSE) +
      ggplot2::labs(subtitle = "Plotting the elapsed scan time for each individual scan") +
      ggplot2::labs(x = "Retentione Time [min]", y = "Elapsed Scan Time [ms]") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::geom_hline(data = xx, ggplot2::aes(yintercept = .data$transient), colour = "red3") -> gp
  }else if (method == 'violin'){
    xx |>
      dplyr::mutate_at(dplyr::vars("ElapsedScanTimesec"), list(~ .*1000)) |>
      dplyr::select_at(dplyr::vars("ElapsedScanTimesec", "rawfile", "MassAnalyzer", "MSOrder")) |>
      na.omit() -> xxx

    ggplot2::ggplot(xxx, ggplot2::aes(x = .data$rawfile, y = .data$ElapsedScanTimesec)) +
      ggplot2::geom_violin()  +
      ggplot2::facet_grid(MSOrder + MassAnalyzer ~ ., scales = "free") +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the retention time resolved elapsed scan time density for each mass spectrometry run") +
      ggplot2::labs(x = "rawfile", y = "Elapsed Scan Time [ms]") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  }else if (method == 'overlay'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime, y = .data$ElapsedScanTimesec,  colour = .data$rawfile)) +
      ggplot2::geom_point(size = 0.5) +
      ggplot2::geom_line(ggplot2::aes(group = "rawfile", colour = "rawfile"), stat = "smooth", method = "gam", formula = y ~ s(x, bs= "cs"), se = FALSE) +
      ggplot2::facet_grid(~ MSOrder + MassAnalyzer, scales = "free") +
      ggplot2::labs(subtitle = "Plotting the elapsed scan time for each individual scan") +
      ggplot2::labs(x = "Retentione Time [min]", y = "Elapsed Scan Time [ms]") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::scale_y_continuous(breaks = scales::pretty_breaks((n = 8))) +
      ggplot2::theme(legend.position="top") -> gp
  }else{NULL}
  gp +
    ggplot2::theme_light() +
    ggplot2::labs(title = "Scan time plot")
}


#' Fill NA values with last previous value
#'
#' @param x a vector of values
#' @author Christian Trachsel
#' @return a vector with any NA values replaced with the last previous actuall value
#'
#' @examples
#' c(NA, 1, 2, 3, NA, 4, 5, NA, NA, NA, 6) |>
#'   rawDiag:::.fillNAgaps()
.fillNAgaps <- function(x) {
  goodVals <- c(NA, x[!is.na(x)])
  fillIdx <- cumsum(!is.na(x))+1
  res <- goodVals[fillIdx]
  return(res)
}

#' Calculate Master Scan Number
#'
#' calculates the MS1 master scan number of an MS2 scan
#' and populates the MasterScanNumber with it
#'
#' @return a \code{data.frame} containing a \code{MasterScanNumber} column.
#' @inheritParams plotLockMassCorrection
#' @importFrom rlang .data
#'
#' @author Christian Trachsel
.calculatioMasterScan <- function(x){
  x |>
    dplyr::mutate(MasterScanNumber = dplyr::case_when(.data$MSOrder == "Ms" ~ .data$scan)) |>
    dplyr::mutate(MasterScanNumber = .fillNAgaps(.data$MasterScanNumber)) |>
    dplyr::mutate(MasterScanNumber = replace(.data$MasterScanNumber, .data$scan == .data$MasterScanNumber, NA)) |>
    dplyr::pull(.data$MasterScanNumber) -> x$MasterScanNumber
 x
}

#' Cycle Load Plot
#'
#' plotting the number of MS2 per MS1 (the duty cycle) scan versus retention
#' time. The deepskyblue colored loess curve shows the trend.
#'
#' @inherit plotLockMassCorrection params return references author
#' @examples
#' rawrr::sampleFilePath() |> rawDiag::readRaw() -> S
#'
#' S |> rawDiag::plotCycleLoad()
#' @export
#' @aliases PlotCycleLoad
plotCycleLoad <- function(x, method = 'trellis'){
  x |>
    .calculatioMasterScan() |>
    dplyr::filter(.data$MSOrder == "Ms2") |>
    dplyr::group_by_at(dplyr::vars("rawfile")) |>
    dplyr::count(.data$MasterScanNumber) |>
    dplyr::rename(scan = .data$MasterScanNumber) -> MS2

  x [, c('StartTime', 'scan')] -> MS

  xx <- dplyr::inner_join(MS, MS2, by = "scan")
  if (method == 'trellis'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime, y = .data$n)) +
      ggplot2::geom_point(shape = ".") +
      ggplot2::geom_line(stat = "smooth",
                         method = "loess",
                         span = 0.2,
                         colour = "deepskyblue3",
                         se = FALSE) +
      ggplot2::facet_wrap(~ rawfile) +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the number of MS2 per MS1 scan versus retention time. The deepskyblue colored loess curve shows the trend.") -> gp
  }else if(method == 'violin'){
    xx <- dplyr::inner_join(MS, MS2, by = "scan") |>
      dplyr::mutate_at(dplyr::vars("rawfile"), list(~ as.factor(.))) |>
      dplyr::mutate_at(dplyr::vars("n"), list(~ as.numeric(.)))

    ggplot2::ggplot(xx, ggplot2::aes(x = .data$rawfile, y = .data$n)) +
      ggplot2::geom_violin() +
      ggplot2::labs(subtitle = "Plotting the duty cycle resolved MS2 density for each mass spectrometry run") +
      ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) -> gp
  }else if (method == 'overlay'){
    ggplot2::ggplot(xx, ggplot2::aes(x = .data$StartTime,
                                     y = .data$n,
                                     colour = .data$rawfile)) +
      ggplot2::geom_point(shape = ".") +
      ggplot2::geom_line(ggplot2::aes(group = .data$rawfile,
                                      colour = .data$rawfile),
                         stat = "smooth", method = "loess", span = 0.2,
                         se = FALSE) +
      ggplot2::labs(title = "Time resolved number of MS2 scans") +
      ggplot2::scale_x_continuous(breaks = scales::pretty_breaks(8)) +
      ggplot2::labs(subtitle = "Plotting the number of MS2 per MS1 scan versus retention time") +
      ggplot2::theme(legend.position = "top") -> gp
  }else{NULL}
  gp +
    ggplot2::labs(title = "Time resolved number of MS2 scans") +
    ggplot2::labs(x = "Retention Time [min]", y = "Number of MS2 per MS1 [counts]") +
    ggplot2::scale_y_continuous(breaks = scales::pretty_breaks(8)) +
    ggplot2::coord_cartesian(ylim = c(0, max(xx$n) + 1)) +
    ggplot2::theme_light()
}

#' Checks Bioconductor installation instructions
#' @importFrom rawrr installRawrrExe
#' @importFrom BiocManager install
#' @return TRUE if everything is installed correctly
#' @export
checkRawrr <- function(){
  if (isFALSE(requireNamespace("BiocManager", quietly = TRUE)))
    stop("exec", "install.packages('BiocManager')")

  if (isFALSE(requireNamespace("rawrr", quietly = TRUE)))
    stop("exec", "BiocManager::install('rawrr')")


  if (isFALSE(file.exists(rawrr:::.rawrrAssembly())))
    rawrr::installRawrrExe()
  if (isFALSE(rawrr:::.isAssemblyWorking()))
    stop("rawrr assembly is not working. check if mono if available.")
  
  TRUE
}


#' @keywords internal
"_PACKAGE"

## usethis namespace: start
## usethis namespace: end
NULL

#R


library(rawDiag)
library(testthat)

rawrr::sampleFilePath() |> rawDiag::readRaw() -> S

test_that("check read.raw", {
	expect_true(is.rawDiag(S))
})



test_that("check plotCycleTime", {
  
  plotCycleTime(S) -> gp
  
  expect_identical(rawDiag:::.cycleTime(S)$CycleTime, gp$data$CycleTime)
  
})


test_that("check plotInjectionTime", {
  
  plotInjectionTime(S) -> gp
  
  expect_identical(S$InjectionTime, gp$data$InjectionTime)
  
})

test_that("check .fillNAgaps", {
  gt <- c(NA, 1, 2, 3, 3, 4, 5, 5, 5, 5, 6)
 
  input <- c(NA, 1, 2, 3, NA, 4, 5, NA, NA, NA, 6)
 
  expect_equal(gt, rawDiag:::.fillNAgaps(input))
})


test_that("check .calculatioMasterScan", {
 gt <- c(529, 529, 529, 529, 529, 529, NA, 551, 551, 551, 551, 551, 551,
 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, 551, NA,573)
 
 output <- (S |> rawDiag:::.calculatioMasterScan())$MasterScan |> tail(30)
 expect_equal(gt, output)
})

#R

#' @noRd
#' @references  https://shiny.posit.co/r/articles/improve/server-function-testing/
shiny::testServer(rawDiagServer,
                  args = list(vals = list(rawfile =  rawrr::sampleFilePath())),
{
  
  expect_true(file.exists(rawfile()))
  expect_true(is.data.frame(data()))
  
  
  session$setInputs(plotFun = "plotInjectionTime")
  session$setInputs(plotArg = "trellis")
  session$setInputs(plotHeight = 400)
  
  expect_true("MSOrder" %in% colnames(data()))
  expect_true("StartTime" %in% colnames(data()))
  expect_true("BasePeakIntensity" %in% colnames(data()))
  expect_true("rawfile" %in% colnames(data()))
  
  expect_true(input$plotFun %in% ls("package:rawDiag")) 
  expect_equal(nrow(data()), 574)
  expect_equal(ncol(data()), 18)
})

---
title: "Brings Orbitrap Mass Spectrometry Data to Life; Fast and Colorful"
author:
- name: Christian Trachsel
- name: Christian Panse
  affiliation:
    - &id Functional Genomics Center Zurich (FGCZ) - University of Zurich | ETH Zurich, Winterthurerstrasse 190, CH-8057 Zurich, Switzerland
    - Swiss Institute of Bioinformatics (SIB), Quartier Sorge - Batiment Amphipole, CH-1015 Lausanne, Switzerland
  email: cp@fgcz.ethz.ch
- name: Tobias Kockmann
  affiliation: *id
package: rawDiag
abstract: |
  Optimizing liquid chromatography coupled to mass spectrometry (LC–MS) methods
  presents a significant challenge. The 'rawDiag' package [@Trachsel2018],
  accessible through `r BiocStyle::Biocpkg('rawDiag')`, streamlines method
  optimization by generating MS operator-specific diagnostic plots based on
  scan-level metadata. Tailored for use on the R shell or as a
  `r BiocStyle::CRANpkg('shiny')` application on the Orbitrap instrument PC,
  'rawDiag' leverages `r BiocStyle::Biocpkg('rawrr')` [@Kockmann2021] for
  reading vendor proprietary instrument data.
  Developed, rigorously tested, and actively employed at the
  Functional Genomics Center Zurich ETHZ | UZH, 'rawDiag' stands as a robust
  solution in advancing LC–MS Orbitrap method optimization."
output:
  BiocStyle::html_document:
    toc_float: true
bibliography: rawDiag.bib
vignette: >
  %\usepackage[utf8]{inputenc}
  %\VignetteIndexEntry{Brings Orbitrap Mass Spectrometry Data to Life; Fast and Colorful}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
urlcolor: blue
---

```{r style, results = 'asis'}
BiocStyle::markdown()
knitr::opts_chunk$set(fig.wide = TRUE, fig.retina = 3, error=FALSE, eval=TRUE)
```


```{r rawDiagLogo, out.width="50%", fig.cap="The octopussy `rawDiag` package logo by Lilly van de Venn."}
knitr::include_graphics("octopussy.png")
```
# Introduction

Over the past two decades, liquid chromatography coupled to mass 
spectrometry (LC–MS) has evolved into the method of choice in the 
field of proteomics. [@Cox2011; @Mallick2010] During a typical 
LC–MS measurement, a complex mixture of analytes is separated by a 
liquid chromatography system coupled to a mass spectrometer (MS) 
through an ion source interface. This interface converts the analytes 
that elute from the chromatography system over time into a beam of 
ions. The MS records from this ion beam a series of mass spectra 
containing detailed information on the analyzed sample. [@Savaryn2016] 
The resulting raw data consist of the mass spectra and their metadata, 
typically recorded in a vendor-specific binary format. During a 
measurement the mass spectrometer applies internal heuristics, which 
enables the instrument to adapt to sample properties, for example, 
sample complexity and amount of ions in near real time. Still, method 
parameters controlling these heuristics need to be set prior to the 
measurement. Optimal measurement results require a careful balancing of 
instrument parameters, but their complex interactions with each other 
make LC–MS method optimization a challenging task.

Here we present `r BiocStyle::Biocpkg('rawDiag')`, a 
platform-independent software tool implemented in the R language [@newS] that 
supports LC–MS operators during the process of empirical method 
optimization. Our work builds on the ideas of the discontinued software 
*rawMeat* (VAST Scientific). Our application is currently 
tailored toward spectral data acquired on Thermo Fisher Scientific 
instruments (raw format), with a particular focus on Orbitrap 
[@Zubarev2013] mass analyzers (Exactive or Fusion instruments). These 
instruments are heavily used in the field of bottom-up proteomics 
[@Aebersold2003] to analyze complex peptide mixtures derived from 
enzymatic digests of proteomes.

`r BiocStyle::Biocpkg('rawDiag')` is meant to run after MS acquisition, 
optimally as an interactive R shiny application, and produces a series 
of diagnostic plots visualizing the impact of method parameter choices 
on the acquired data across injections. If static reports are required 
then pdf files can be generated using
`r BiocStyle::CRANpkg('rmarkdown')`. In this vignette, we present the 
usage of our tool.

`r BiocStyle::Biocpkg('rawDiag')` gains advantages from being part of
the Bioconductor ecosystem, such as its ability to utilize the
`r BiocStyle::Biocpkg('rawrr')` package and potentially extend its
functionality through interaction with the `r BiocStyle::Biocpkg('Spectra')`
infrastructure, particularly with the
`r BiocStyle::Biocpkg('MsBackendRawFileReader')`.

# Requirements

`r BiocStyle::Biocpkg('rawDiag')` proides a wrapper function `readRaw` using the
`r BiocStyle::Biocpkg('rawrr')` methods `raw::readIndex`, `rawrr::readTrailer`,
and `rawrr::readChromatogram` to read proprietary mass spectrometer generated
data by invoking third-party managed methods through a `system2`
`text connection`.
The `r BiocStyle::Biocpkg('rawrr')` package provides the entire stack below,
which `r BiocStyle::Biocpkg('rawDiag')` utilizes.

<table>
<tr style="border:2px solid black">
<td style="padding:15px">
`R>`
</td>
</tr>

<tr style="border:2px solid black">
<td style="padding:15px">
`text connection`
</td>
</tr>

<tr style="background-color:yellow;color:black; border:2px solid black">
<td style="padding:15px">
`system2`
</td>
</tr>

<tr style="background-color:yellowgreen;color:black; border:2px solid black">
<td style="padding:15px">
Mono Runtime
</td>
</tr>

<tr style="background-color:orange;color:black; border:2px solid black">
<td style="padding:15px">
Managed Assembly
(CIL/.NET code)
<br>
rawrr.exe
</td>
</tr>

<tr style="background-color:orange;color:black; border:2px solid black">
<td style="padding:15px">
ThermoFisher.CommonCore.*.dll
</td>
</tr>
</table>


# Install

## OS dependencies
### Linux (debian/ubuntu)

In case you prefer to compile `rawrr.exe` from C# source code, please install
the mono compiler and xbuild by installing the following Linux packages:


To install this package, start R (version ">=4.4") and enter: 

```{r installRawrr, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("rawrr")
```

assemblies aka Common Intermediate Language bytecode - the download and install
can be done on all platforms using the command:

```{r checkInstallRequirements}
rawDiag::checkRawrr
rawDiag::checkRawrr()

rawrr::installRawrrExe()
```

```{r listrawrrAssemblyPath}
rawrr::rawrrAssemblyPath()
rawrr::rawrrAssemblyPath() |> list.files()
```

for more information please read the INSTALL file in the
`r BiocStyle::Biocpkg('rawrr')` package.

# Usage

## R command line

### Input

fetch example Orbitrap raw files from
`r BiocStyle::Biocpkg('ExperimentHub')`'s `r BiocStyle::Biocpkg('tartare')`
package.

```{r fetchFromExperimentHub}
library(ExperimentHub)
ExperimentHub::ExperimentHub() -> eh
normalizePath(eh[["EH3222"]]) -> EH3222
normalizePath(eh[["EH4547"]]) -> EH4547

(rawfileEH3222 <- paste0(EH3222, ".raw"))
if (!file.exists(rawfileEH3222)){
  file.copy(EH3222, rawfileEH3222)
}

(rawfileEH4547 <- paste0(EH4547, ".raw"))
if (!file.exists(rawfileEH4547)){
  file.copy(EH4547, rawfileEH4547)
}

c(rawfileEH3222, rawfileEH4547) -> rawfile
```
Of note, the *proprietary* .Net assemblies [@RFR] require a file extentention of `.raw`. Therfore we have to rename the EH files and add the `.raw` suffix.

list meta data of the raw files.

```{r header}
(rawfile |>
  lapply(FUN = rawrr::readFileHeader) -> rawFileHeader)
```

### `readRaw` - read Orbitrap raw file 

read the two instrument raw files by using the `r BiocStyle::Biocpkg('rawDiag')`
package.

```{r readEH4547OrbitrapTrailerTable}
rawfile |>
  lapply(FUN = rawDiag::readRaw) |>
  Reduce(f = rbind) -> x
  #BiocParallel::bplapply(FUN = rawDiag::readRaw) |>
```

### Output -  Visualization

This package provides several plot functions tailored toward MS data. 
The following list shows all available plot methods.

```{r listFUN}
library(rawDiag)
ls("package:rawDiag") |>
  grep(pattern = '^plot', value = TRUE) -> pm

pm |>
  knitr::kable(col.names = "package:rawDiag plot functions")
```

An inherent problem of visualizing data is the fact that depending on the data
at hand, specific visualizations lose their usefulness, e.g., overplotting in
a scatter plot if too many data points are present. To address this problem, we implemented most of the plot functions in different versions inspired by the
work of @Cleveland1993, @Sarkar2008, and @Wickham2009. The data can be displayed
in trellis plot manner using the faceting functionality of
`r BiocStyle::CRANpkg('ggplot2')`. Alternatively, overplotting using color
coding or violin plots based on descriptive statistics values can be chosen,
which allows the user to interactively change the appearance of the plots based
on the situation at hand. For instance, a large number of files are best
visualized by violin plots, giving the user an idea about the distribution of
the data points. On the basis of this, a smaller subset of files can be selected
and visualized with another technique.

The code snippet below applies all plot methods on the example data.

```{r plotALL, fig.width = 10, fig.height = 5}
pm |> 
  lapply(FUN = function(plotFUN) {
    lapply(c('trellis'), function(method) {
      message("plotting", plotFUN, "using method", method, "...")
      do.call(plotFUN, list(x, method)) 
    })
  }) 
```

The appearance of each plot depends on the instrument, sample, and method used
to acquire the data. Therefore, it is hard to say what each ideal plot should
look like. 
In particular, in the example above, we use data generated on an
`r rawFileHeader[[1]]$"Instrument name"`, `r rawFileHeader[[1]]$"RAW file"` and
`r rawFileHeader[[2]]$"Instrument name"`, `r rawFileHeader[[2]]$"RAW file"`
instrument using data-independent acquisition (DIA) [@Bruderer2017] and
data-dependent acquisition (DDA) methods.
For more information on the plot methods and its application, please read the
package man pages and the application examples in the manuscript
[@Trachsel2018].

## Launching the shiny application

The package provides a simple interactive `r BiocStyle::Biocpkg('shiny')`-based
graphical user interface for exploring Thermo Fisher Scientific *raw* data.

If you have a directory containing raw files, you can create a shiny application
as follows:

```{r shinyApp}
rawfile |>
  dirname() |>
  rawDiag::buildRawDiagShinyApp() -> app
```

The `r BiocStyle::Biocpkg('shiny')` runApp function launches the app in our
browser.

```{r runApp, eval=FALSE}
shiny::runApp(app)
```

By default, the application lets you choose the raw files in the provided
directory and provides the visualizations of the raw data as output.
The user can interactively change the by the
`r BiocStyle::Biocpkg('rawDiag')`
the package provided plot functions and arguments.

Additionally, the application provides PDF generation and download buttons.
Optionally height and width can be changed in the user interface.

Of note, the `rawDiag::rawDiagServer` module can be integrated into an existing
`r BiocStyle::CRANpkg('shinydashboard')` application, e.g., https://shiny-ms.fgcz.uzh.ch/fgczmsqc-dashboard/.

# FAQ

## I would like to load multiple files into a single data.frame to do comparisons; what is the preferred method for doing so?

consider all raw files of your working directory, e.g., `~/Downloads` and load them.

```{r FAQ1, eval=FALSE}
file.path(Sys.getenv("HOME"), "Downloads") |>
  setwd()

list.files() |>
  grep(pattern = '*.raw$', value = TRUE) |> 
  lapply(FUN = rawDiag::readRaw) |> 
  Reduce(f = rbind) -> x
```

as alternative to `lapply` you can utilize the
`r BiocStyle::Biocpkg('BiocParallel')` package `bplapply` function.

# References {-}

# Session information {-}

```{r sessioninfo, eval=TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{plotCycleTime}
\alias{plotCycleTime}
\alias{PlotCycleTime}
\title{Plot Cycle Time}
\usage{
plotCycleTime(x, method = "trellis")
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}

\item{method}{specifying the plot method 'trellis' | 'violin' | 'overlay'.
The default is 'trellis'.}
}
\value{
a \code{\link[ggplot2]{ggplot}} object.
}
\description{
graphs the time difference between two consecutive MS1 scans
(cycle time) with respect to RT (scatter plots) or its density (violin).
A smooth curve graphs the trend. The 95th percentile is indicated by a red
dashed line.
}
\examples{
rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotCycleTime()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{.calculatioMasterScan}
\alias{.calculatioMasterScan}
\title{Calculate Master Scan Number}
\usage{
.calculatioMasterScan(x)
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}
}
\value{
a \code{data.frame} containing a \code{MasterScanNumber} column.
}
\description{
calculates the MS1 master scan number of an MS2 scan
and populates the MasterScanNumber with it
}
\author{
Christian Trachsel
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{plotTicBasepeak}
\alias{plotTicBasepeak}
\alias{PlotTicBasepeak}
\title{Total Ion Count and Base Peak Plot}
\usage{
plotTicBasepeak(x, method = "trellis")
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}

\item{method}{specifying the plot method 'trellis' | 'violin' | 'overlay'.
The default is 'trellis'.}
}
\value{
a ggplot2 object for graphing the TIC and the Base Peak chromatogram.
}
\description{
displays the Total Ion Count (TIC) and the Base Peak Chromatogram
of a mass spectrometry measurement.
Multiple files are handled by faceting based on rawfile name.
}
\examples{
rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotTicBasepeak()
}
\author{
Christian Trachsel (2017), Christian Panse (20231130) refactored
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{is.rawDiag}
\alias{is.rawDiag}
\title{Is an Object an rawDiag Object?}
\usage{
is.rawDiag(object)
}
\arguments{
\item{object}{any \R object.}
}
\value{
a boolean
}
\description{
Is an Object an rawDiag Object?
}
\examples{
rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::is.rawDiag()

}
\author{
Christian Panse 2018
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{readRaw}
\alias{readRaw}
\alias{rawDiag}
\title{Reads selected raw file trailer information for rawDiag plot functions}
\usage{
readRaw(
  rawfile,
  msgFUN = function(x) {
     message(x)
 }
)
}
\arguments{
\item{rawfile}{the name of the raw file containing the mass spectrometry data from the Thermo Fisher Scientific instrument.}

\item{msgFUN}{this function is used for logging information while composing
the resulting data.frame. It can also be used for shiny progress bar. The
default is using the \code{message}.}
}
\value{
a \code{data.frame} containing the selected trailer information.
}
\description{
implements a wrapper function using the rawrr methods
\code{\link[rawrr]{readIndex}}, \code{\link[rawrr]{readTrailer}},
and \code{\link[rawrr]{readChromatogram}} to read
proprietary mass spectrometer generated data using third-party libraries.
}
\note{
The set up procedure for the rawrr package needs to be run in order to use
this package.
}
\examples{
rawDiag::checkRawrr()
rawrr::sampleFilePath() |>
  rawDiag::readRaw()
}
\references{
\doi{10.1021/acs.jproteome.8b00173}
}
\author{
Christian Panse (2016-2023)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\docType{package}
\name{rawDiag-package}
\alias{rawDiag-package}
\title{rawDiag: Brings Orbitrap Mass Spectrometry Data to Life; Fast and Colorful}
\description{
Optimizing methods for liquid chromatography coupled to mass spectrometry (LC-MS) poses a nontrivial challenge. The rawDiag package facilitates rational method optimization by generating MS operator-tailored diagnostic plots of scan-level metadata. The package is designed for use on the R shell or as a Shiny application on the Orbitrap instrument PC.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/fgcz/rawDiag/}
  \item Report bugs at \url{https://github.com/fgcz/rawDiag/issues}
}

}
\author{
\strong{Maintainer}: Christian Panse \email{cp@fgcz.ethz.ch} (\href{https://orcid.org/0000-0003-1975-3064}{ORCID})

Authors:
\itemize{
  \item Christian Trachsel \email{Christian.Trachsel@fgcz.ethz.ch}
  \item Tobias Kockmann \email{Tobias.Kockmann@fgcz.ethz.ch}
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{plotMzDistribution}
\alias{plotMzDistribution}
\alias{PlotMzDistribution}
\title{mZ Distribution Plot of Ms2 Scans}
\usage{
plotMzDistribution(x, method = "trellis")
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}

\item{method}{specifying the plot method 'trellis' | 'violin' | 'overlay'.
The default is 'trellis'.}
}
\value{
a \code{\link[ggplot2]{ggplot}} object.
}
\description{
draws precursor mass vs retention time for each MS2 scan in the raw file.
}
\examples{
rawrr::sampleFilePath() |> rawDiag::readRaw() -> S
rawDiag::plotMzDistribution(S)
}
\references{
\itemize{
\item rawDiag: \doi{10.1021/acs.jproteome.8b00173},
\item rawrr: \doi{10.1021/acs.jproteome.0c00866}
}
}
\author{
Christian Trachsel (2017), Christian Panse (2023)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{plotPrecursorHeatmap}
\alias{plotPrecursorHeatmap}
\alias{PlotPrecursorHeatmap}
\title{Precursor Mass versus StartTime MS2 based hexagons}
\usage{
plotPrecursorHeatmap(x, method = "overlay", bins = 80)
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}

\item{method}{specifying the plot method 'trellis' | 'violin' | 'overlay'.
The default is 'trellis'.}

\item{bins}{number of bins in both vertical and horizontal directions. default is 80.}
}
\value{
a \code{\link[ggplot2]{ggplot}} object.
}
\description{
Precursor Mass versus StartTime MS2 based hexagons
}
\note{
TODO: define bin with dynamically as h= 2x IQR x n e-1/3 or number of bins (max-min)/h
}
\examples{
rawrr::sampleFilePath() |> rawDiag::readRaw() |> rawDiag::plotPrecursorHeatmap()
}
\references{
\itemize{
\item rawDiag: \doi{10.1021/acs.jproteome.8b00173},
\item rawrr: \doi{10.1021/acs.jproteome.0c00866}
}
}
\author{
Christian Trachsel (2017)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny.R
\name{rawDiagUI}
\alias{rawDiagUI}
\title{rawDiag shiny module UI}
\usage{
rawDiagUI(id)
}
\arguments{
\item{id}{An ID string that corresponds with the ID used to call the module's
UI function.}
}
\value{
a shiny UI module

rawDiag shiny module UI
}
\description{
rawDiag shiny module UI
}
\examples{
\dontshow{if (interactive()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
rawDiag::shiny(rawDir = (rawrr::sampleFilePath() |> dirname()))
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shiny.R
\name{buildRawDiagShinyApp}
\alias{buildRawDiagShinyApp}
\title{Build the rawDiag shiny application}
\usage{
buildRawDiagShinyApp(rawDir = (dirname(rawrr::sampleFilePath())))
}
\arguments{
\item{rawDir}{A directory containing the input raw files,
default is set to the \code{$HOME/Downloads} directory.}
}
\value{
returns the rawDiag shiny apps
}
\description{
Build the rawDiag shiny application
}
\note{
launch the shiny application by embracing your command line while
expecting the raw file in \code{$HOME/Downloads}
\itemize{
\item MacOSX and Linux: \verb{R -q -e "library(rawDiag); buildRawDiagShinyApp() |> shiny::runApp(launch.browser = TRUE)"}
\item Microsoft Windows: \verb{R.exe -e "library(rawDiag); buildRawDiagShinyApp() |> shiny::runApp(launch.browser = TRUE)"}
}
}
\examples{
\dontshow{if (interactive()) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
rawrr::sampleFilePath() |>
  dirname() |>
  rawDiag::buildRawDiagShinyApp() |>
  shiny::runApp()
  
 # or use your 'Download' folder
 (Sys.getenv('HOME') |>
   file.path("Downloads")) |>
   rawDiag::buildRawDiagShinyApp() |>
   shiny::runApp()
\dontshow{\}) # examplesIf}
}
\references{
\itemize{
\item rawDiag: \doi{10.1021/acs.jproteome.8b00173},
\item rawrr: \doi{10.1021/acs.jproteome.0c00866}
}
}
\author{
Christian Trachsel (2017), Christian Panse (2023)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{plotScanTime}
\alias{plotScanTime}
\alias{PlotScanTime}
\title{Scan Event Plot}
\usage{
plotScanTime(x, method = "trellis")
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}

\item{method}{specifying the plot method 'trellis' | 'violin' | 'overlay'.
The default is 'trellis'.}
}
\value{
a \code{\link[ggplot2]{ggplot}} object.
}
\description{
Plotting the elapsed scan time for each individual scan event.
}
\examples{
## for debugging bioconductor check
 if (Sys.info()['sysname'] \%in\% c("Darwin", "Linux")) {Sys.which('mono')}
 rawrr::sampleFilePath() |> rawDiag::readRaw() -> S

rawDiag::checkRawrr()

S |> rawDiag::plotScanTime()
}
\references{
\itemize{
\item rawDiag: \doi{10.1021/acs.jproteome.8b00173},
\item rawrr: \doi{10.1021/acs.jproteome.0c00866}
}
}
\author{
Christian Trachsel (2017), Christian Panse (2023)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{.fillNAgaps}
\alias{.fillNAgaps}
\title{Fill NA values with last previous value}
\usage{
.fillNAgaps(x)
}
\arguments{
\item{x}{a vector of values}
}
\value{
a vector with any NA values replaced with the last previous actuall value
}
\description{
Fill NA values with last previous value
}
\examples{
c(NA, 1, 2, 3, NA, 4, 5, NA, NA, NA, 6) |>
  rawDiag:::.fillNAgaps()
}
\author{
Christian Trachsel
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{checkRawrr}
\alias{checkRawrr}
\title{Checks Bioconductor installation instructions}
\usage{
checkRawrr()
}
\value{
TRUE if everything is installed correctly
}
\description{
Checks Bioconductor installation instructions
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rawDiag.R
\name{.cycleTime}
\alias{.cycleTime}
\title{Calculate MS Cycle Time}
\usage{
.cycleTime(x)
}
\arguments{
\item{x}{a \code{data.frame} object adhering to the specified criteria for
the \code{is.rawDiag} function.}
}
\value{
calculates the time of all ms cycles and the 95% quantile value there of.
the cycle time is defined as the time between two consecutive MS1 scans
}
\description{
calculates the lock mass deviations along RT.
}
\note{
TODO: quantile part needed? If no MS1 scan is present?
E.g., DIA take lowest window as cycle indicator?
}
\author{
Christian Trachsel (2017), Christian Panse (20231201) refactored
}
